<template>
    <RouterLink to="/" title="Back to all users" class="text-lg font-semibold transition-colors hover:text-black/80">
        &larr; All users
    </RouterLink>

    <div v-if="!data.person" class="my-24">
        <Spinner class="w-40 h-40" />
    </div>
    
    <div v-else class="mt-6">
        <div class="grid md:pb-2 border-black md:border-b md:grid-cols-12 md:gap-16 lg:gap-[76px]">
            <h1 class="pb-2 border-b border-black md:pb-0 md:col-span-5 xl:col-span-3 md:border-0">{{ pageTitle(data.person.fields.Name) }}</h1>

            <span class="self-end mt-2 text-sm font-bold capitalize text-zinc-400 md:col-span-4 xl:col-span-6 md:mt-0">{{ data.person.fields.Role }}</span>
            
            <template v-if="data.person.fields['Is requestable']">
                <div v-if="state.requestsAlreadySent[data.person.id]" class="font-bold place-self-start md:place-self-end md:col-span-3 ">
                    Friend request already sent
                </div>

                <button v-else @click="sendRequest()" :disabled="data.isLoadingRequest" class="px-4 py-1.5 text-xs font-extrabold border border-black rounded-full bg-[#8DCC7B] mt-4 md:mt-0 place-self-start md:place-self-end md:col-span-3 hover:bg-[#A3D495] transition-colors disabled:opacity-50 disabled:cursor-not-allowed">
                    <Spinner v-if="data.isLoadingRequest" class="w-4 h-4 px-6"/>
                    <template v-else>Send Request</template>
                </button>
            </template>

            <img v-else src="../assets/img/Small-G.svg" alt="Big-G logo" class="h-6 mt-4 md:mt-0 md:h-8 md:place-self-end md:col-span-3">
        </div>

        <div class="grid pt-4 md:pt-9 md:grid-cols-12 md:gap-16 lg:gap-[76px]">
            <img :src="data.person.fields['Profile image'][0].url" :alt="data.person.name" class="object-cover w-full rounded-lg md:col-span-5 xl:col-span-3 h-96">
    
            <div class="xl:col-span-9 md:col-span-7">
                <q class="block max-w-[400px] my-10 md:mb-14 md:mt-3">{{ data.person.fields.Quote }}</q>
    
                <p>{{ data.person.fields.Bio }}</p>
            </div>
        </div>
    </div>
</template>

<script setup>
import { reactive, onMounted } from 'vue';
import { useRoute } from 'vue-router';
import Spinner from '../components/Spinner.vue';
import axios from 'axios';
import state from './state';

const data = reactive({
    person: null,
    isLoadingRequest: false,
});

onMounted(()=>{
    getPerson();
});

//carico i dati della persona
const getPerson = async ()=>{
    await axios.get('https://api.airtable.com/v0/app7cLoZ4xMOrQvKR/People/' + useRoute().params.id, {
        headers: {
            Authorization: 'Bearer ' + import.meta.env.VITE_API_TOKEN
        }
    })
    .then((res)=>{
        data.person = res.data;
    });
}

//invio richiesta amicizia
const sendRequest = async ()=>{
    data.isLoadingRequest = true;

    const bodyParameters = {
        "records": [
            {
                "fields": {
                    "From": "Aldo C.",
                    "To": [
                        data.person.id
                    ]
                }
            }
        ]
    };

    await axios.post('https://api.airtable.com/v0/app7cLoZ4xMOrQvKR/Friend%20request', bodyParameters, {
        headers: {
            Authorization: 'Bearer ' + import.meta.env.VITE_API_TOKEN,
            'Content-Type': 'application/json'
        }
    })
    .then((res)=>{
        state.request = res.data;
        
        data.isLoadingRequest = false;
        
        //memorizzo la richiesta per non richiederla più di una volta
        state.requestsAlreadySent[data.person.id] = true
    });
}

//imposto il titolo della pagina
const pageTitle = (name)=>{
    document.title = name;

    return name;
}

</script>
